#!/usr/bin/env python3
# -*- encoding: cp936 -*-

#
# Author: bluerust, scz
#

#
# IDA 7.5.1+Python 3.9
#
# "c:\windows\system.ini"MD5IDAп
#
# Opening 0x7fff1e33fa90
# ret = 0
# 00000000: 28 6A 9E DB 37 9D C3 42  3A 52 8B 08 64 A0 F1 11  (j..7..B:R..d...
# 00000010: 00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  ................
# Closing 0x7fff1e33fa90
#
# Աֵ
#
# $ wsl md5sum /mnt/c/windows/system.ini
# 286a9edb379dc3423a528b0864a0f111  /mnt/c/windows/system.ini
#

import sys, ctypes, inspect, traceback, functools
import hexdump
import flare_emu

#
# dir(ctypes)
# dir(ctypes.cdll)
#
cso                 = ctypes.cdll.msvcrt

#
# https://docs.python.org/3/library/ctypes.html
#
# ο"Fundamental data types"ԱNoneType
#
# >>> ctypes.sizeof( VOIDP )
# 8
#
class VOIDP ( ctypes.c_void_p ) :

    #
    # ſԶVOIDPint()
    #
    def __int__ ( self ) :
        return self.value

#
# end of class VOIDP
#

#
# Ϊָԭָͣrestype(ֵ)argtypes()
# ״"δ"
#
# FILE *fopen(const char *pathname, const char *mode);
# size_t fread(void *ptr, size_t size, size_t nmemb, FILE *stream);
# int fclose(FILE *stream);
# void *calloc(size_t nmemb, size_t size);
# void free(void *ptr);
# void *memmove(void *dest, const void *src, size_t n);
#
# >>> ctypes.sizeof( ctypes.c_size_t )
# 8
#
cso.fopen.argtypes      = ( ctypes.c_char_p, ctypes.c_char_p )
cso.fopen.restype       = VOIDP

cso.fread.argtypes      = ( VOIDP, ctypes.c_ulong, ctypes.c_ulong, VOIDP )
cso.fread.restype       = ctypes.c_size_t

#
# ֻ[]()
#
cso.fclose.argtypes     = [ VOIDP ]
cso.fclose.restype      = ctypes.c_int

cso.calloc.argtypes     = ( ctypes.c_size_t, ctypes.c_size_t )
cso.calloc.restype      = VOIDP

cso.free.argtypes       = [ VOIDP ]
cso.free.restype        = None

#
# ʵctypes.memmove()ctypes.memset()ҪԼ׼
#
cso.memmove.argtypes    = ( VOIDP, VOIDP, ctypes.c_size_t )
cso.memmove.restype     = VOIDP

#
# Be called before each instruction is emulated.
#
def PrivateInstructionHook ( unicornObject, address, instructionSize, userData ) :
    #
    # Ҫٵָע͵
    #
    print( "=> %#x [%s]" % ( address, ida_lines.tag_remove( ida_lines.generate_disasm_line( address ) ) ) )
    pass
#
# end of PrivateInstructionHook
#

#
# How can I find the number of arguments of a Python function
# https://stackoverflow.com/questions/847936/how-can-i-find-the-number-of-arguments-of-a-python-function
#
def GetFuncParamNum ( func ) :
    sig = inspect.signature( func )
    return len( sig.parameters )
#
# end of GetFuncParamNum
#

#
# װο
#
# https://www.programiz.com/python-programming/decorator (Ƽ)
# https://www.python-course.eu/python3_decorators.php
# https://www.runoob.com/w3cnote/python-func-decorators.html
#
# һͨװ
#
def PrivateHook ( func ) :

    #
    # args will be the tuple of positional arguments and kwargs will be
    # the dictionary of keyword arguments.
    #
    # ʽ
    #
    # func_wrapper.__name__   = func.__name__
    # func_wrapper.__doc__    = func.__doc__
    # func_wrapper.__module__ = func.__module__
    #
    @functools.wraps(func)
    def func_wrapper ( *args, **kwargs ) :
        #
        # print( func.__name__ )
        # print( args )
        # print( kwargs )
        #
        # οflare_emu_hooks.py漰ĺԭ
        #
        # (eh, address, argv, funcName, userData)
        #
        eh          = args[0]
        address     = args[1]
        #
        # flare-emu޷֪βֻͣǰһABI̶ȡ8ʵΣ
        # 㴫λDelphiֵԼԼȡʵ
        #
        argv        = args[2]
        funcName    = args[3]
        userData    = args[4]
        try :
            #
            # 1Ǽȥehռβ
            #
            n   = GetFuncParamNum( func ) - 1
            #
            # ݲβ
            #
            ret = func( eh, *argv[:n] )
            #
            # hook_free()᷵None
            #
            if ret is not None :
                eh.uc.reg_write( eh.regs["ret"], ret )
            return ret
        except :
            traceback.print_exc()
            sys.exit()
    #
    # end of func_wrapper
    #

    return func_wrapper
#
# end of PrivateHook
#

#
# ԭʼͼFILEṹͬʵо޿ӵǡWindowsģ
# ִELFΣOSFILEṹ岢ͬ
#
def update_stream ( eh, stream ) :
    f   = eh.ftable[stream]
    buf = ctypes.create_string_buffer( 256 )
    assert( buf )
    cso.memmove( buf, f, 256 )
    #
    # FILEṹЧ
    #
    # hexdump.hexdump( buf )
    #
    # дGuest̿ռ
    #
    eh.writeEmuMem( stream, buf.raw[:256] )
#
# end of update_stream
#

#
# bluerustİ汾
#
@PrivateHook
def hook_fread ( eh, ptr, size, nmemb, stream ) :
    f   = eh.ftable[stream]
    p   = ctypes.create_string_buffer( size * nmemb )
    n   = cso.fread( p, size, nmemb, f )
    update_stream( eh, stream )
    #
    # p.rawbytesͣptrָGuest̿ռ
    #
    eh.writeEmuMem( ptr, p.raw[:size * n] )
    return n
#
# end of hook_fread
#

#
# sczİ汾߶
#
# @PrivateHook
# def hook_fread ( eh, ptr, size, nmemb, stream ) :
#     f   = eh.ftable[stream]
#     p   = cso.calloc( nmemb, size )
#     n   = cso.fread( p, size, nmemb, f )
#     update_stream( eh, stream )
#     eh.writeEmuMem( ptr, ctypes.string_at( p, size * n ) )
#     cso.free( p )
#     return n
# #
# # end of hook_fread
# #

@PrivateHook
def hook_fclose( eh, stream ):
    f   = eh.ftable[stream]
    ret = cso.fclose( f )
    update_stream( eh, stream )
    return ret
#
# end of hook_fclose
#

@PrivateHook
def hook_free ( eh, ptr ) :
    #
    # ַNone
    #
    return

def main () :

    #
    # ǰû"@functools.wraps(func)"˴"func_wrapper"֮
    # "hook_fread"
    #
    # print( hook_fread.__name__ )
    #

    eh              = flare_emu.EmuHelper()

    #
    # οflare_emu.pyѾhook malloc()Լ
    #
    # Ŀbinaryfeof()ferror()inlineչ޷eh.addApiHook()
    #

    #
    # ˴hook_fread()ԭ
    #
    # (eh, address, argv, funcName, userData)
    #
    # ˴д"_fread_unlocked""_free"Ҳ
    #
    eh.addApiHook( "fread_unlocked", hook_fread )
    eh.addApiHook( "free", hook_free )

    f               = cso.fopen( b"c:\\windows\\system.ini", b"rb" )
    if not f :
        print( "Unable to open file" )
        return
    print( "Opening", hex( int( f ) ) )

    #
    # ȡģ⺯ʼַ
    #
    startAddr       = eh.analysisHelper.getNameAddr( "md5_stream" )
    assert( startAddr and startAddr != 0 )
    #
    # ׼ģ⺯βΣGuest̿ռڴ
    #
    FILE            = eh.allocEmuMem( 256 )
    resblock        = eh.allocEmuMem( 0x20 )

    #
    # Լʱӵԣڴļ(FILE*)
    #
    eh.ftable       = dict()
    eh.ftable[FILE] = f

    update_stream( eh, FILE )

    #
    # οflare_emu.py
    #
    # x64/Win10üĴʵΣģ/ִmd5_stream()
    #
    # eh.emulateRange( startAddr, skipCalls=False, instructionHook=PrivateInstructionHook, registers={'arg1':FILE, 'arg2':resblock} )
    #
    # Ҫٵָע͵䣬
    #
    eh.emulateRange( startAddr, skipCalls=False, registers={'arg1':FILE, 'arg2':resblock} )
    #
    # ȡģ/ִmd5_stream()ֵ
    #
    ret             = eh.getRegVal( "rax" )
    print( "ret =", ret )
    #
    # ȡMD5
    #
    md5             = eh.getEmuBytes( resblock, 0x20 )
    hexdump.hexdump( md5 )
    #
    # ֻһҪر
    #
    for k,v in eh.ftable.items() :
        if v :
            cso.fclose( v )
            print( "Closing", hex( int( v ) ) )
#
# end of main
#

if __name__ == '__main__' :
    main()
